//+------------------------------------------------------------------+
//|                                                   Farnsworth.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                               http://www.mql4.com/ru/users/IgorM |
//+------------------------------------------------------------------+
#property copyright "IgorM"
#property link      "http://www.mql4.com/ru/users/IgorM"

extern int window=290;

string sym[14]={"AUDJPY","AUDUSD","CHFJPY","EURCHF","EURGBP","EURJPY",
                "EURUSD","GBPCHF","GBPJPY","GBPUSD","NZDUSD","USDCAD","USDCHF","USDJPY"};
int period[9] ={PERIOD_M1, PERIOD_M5, PERIOD_M15, PERIOD_M30, PERIOD_H1, PERIOD_H4, PERIOD_D1, PERIOD_W1, PERIOD_MN1};

int start(){
   int n,Handle,i=0;
   while(!loadhistory()){i++;Comment("  ",i);Sleep(50);}
   Comment("");
   double HL[14];
   string FileName="quatation.csv";
   Handle=FileOpen(FileName, FILE_CSV|FILE_WRITE," ");
   if(Handle==-1){
      Alert("   ",GetLastError());
      return(-1);
   }
   FileWrite(Handle, sym[0], sym[1], sym[2], sym[3], sym[4], sym[5], sym[6], sym[7], sym[8], sym[9], sym[10], sym[11], sym[12], sym[13]);
   for(n=window-1; n>0; n--){
      for(i=0;i<14;i++) HL[i] =(iHigh(sym[i], PERIOD_D1, n)+iLow(sym[i], PERIOD_D1, n))/2.0;
      FileWrite(Handle, HL[0],HL[1], HL[2], HL[3], HL[4], HL[5], HL[6], HL[7], HL[8], HL[9], HL[10], HL[11], HL[12], HL[13]);
   }
   FileClose(Handle);
   Alert("   !");
return(0);
}
//_____________________________________________________________________
bool loadhistory(){
   double high[];
   int err = GetLastError();
   bool result = true;
   for(int j=0;j<14;j++){
      for(int i=0;i<9;i++){
            ArrayCopySeries(high,MODE_HIGH,sym[j],period[i]);
            err = GetLastError();
            if (err > 0) result = false;
            Sleep(10);
      }
   }   
return(result);
}